#Code 2.7 Density of the logistic map, 1 trajectory (logistic_density.R)

f.x<- function(x,r){
  r*x*(1-x)
}
##### function to compute  the time trajectory #####
f.temp<-function(xinit,nstep,r){ # starting function f.temp
  xt<- numeric()
  x<- xinit
  xt[1]<- x
  for(i in 2:nstep){
    y<- f.x(x,r)
    x<- y
    xt[i]<- x
  }
  return(xt)
} # ending function f.temp
### parameters and initial conditions
r<- 4
xinit<- 0.2
nstep<- 1000
xt<- f.temp(xinit,nstep,r) # iterates
lbin<- 0.05
par(mai=c(1.02,1.,0.82,0.42)+0.1)
hist(xt,freq=F,xlab="x(t)",ylab="density",main="",br=seq(0,1,by=lbin),
     cex.axis=1.2,cex.lab=1.5)
curve(dbeta(x, 0.5,0.5),lty=2,col="black",add=T,lwd=1)
# random process
windows()
set.seed(1)   # seed of the sequence of (pseudo) random numbers
xt<-runif(nstep,0,1)
par(mai=c(1.02,1.,0.82,0.42)+0.1)
hist(xt,freq=F,xlab="x(t)",ylab="density",main="",br=seq(0,1,by=lbin),
     ylim=c(0,3),cex.axis=1.2,cex.lab=1.5)